<?php
@header("Content-type: text/html;charset=utf-8");
define('SELF', pathinfo(__FILE__, PATHINFO_BASENAME));
define('FCPATH', str_replace("\\", "/", str_replace(SELF, '', __FILE__)));

if(isset($_GET['id'])){
    $id = $_GET['id']; // 豆瓣ID或链接
    $callback = $_GET['callback'];
    
    // 如果传入的是豆瓣链接，则提取ID
    if(strpos($id, ".com") !== false) {
        $parts = explode("subject/", $id);
        if(count($parts) > 1) {
            $id = explode("/", $parts[1])[0];
        }
    }
    
    $file = FCPATH.'/douban/'.$id.'.txt';
    if(file_exists($file)){
        $vurl = file_get_contents($file);
    } else {
        $data = geturl('https://movie.douban.com/subject/'.$id.'/');
        $data = str_replace(" / ",",", $data); // 替换别名分隔符
        
        // 从豆瓣页面提取电影名称，包含外文名称
        //$d_name = str_substr('<span property="v:itemreviewed">','</span>', $data);
        // 从页面标题中获取电影名称，不含外文名称
        $d_name = trim(str_substr('<title>', ' (', $data));
        
        if(empty($d_name)){
            // 如果电影名称为空，则返回错误信息
            $vurl = '({"code":102,"auth":"冷曦博客免费转发分享！","msg":"博客www.lengxi.net"});';
        } else {
            // 继续提取其他信息
            $vod_score    = str_substr('<strong class="ll rating_num" property="v:average">','</strong>', $data); // 评分
            $vod_reurl    = str_substr('data-url="','"', $data); // 豆瓣地址
            $vod_year     = str_substr('<span class="year">(',')</span>', $data); // 年代
            
            $txt1         = str_substr("导演</span>: <span class='attrs'>","</span></span><br/>", $data);
            $vod_director = preg_replace("/<a[^>]*>(.*)<\/a>/isU", '${1}', $txt1); // 导演
            
            $txt          = str_substr("主演</span>: <span class='attrs'>","</span></span><br/>", $data);
            $vod_actor    = preg_replace("/<a[^>]*>(.*)<\/a>/isU", '${1}', $txt); // 主演
            
            $txt5         = str_substr("编剧</span>: <span class='attrs'>","</span></span><br/>", $data);
            $vod_writer   = preg_replace("/<a[^>]*>(.*)<\/a>/isU", '${1}', $txt5); // 编剧
            
            $txt2         = str_substr("类型:</span> ","<br/>", $data);
            $vod_class    = preg_replace("/<span[^>]*>(.*)<\/span>/isU", '${1}', $txt2); // 分类
            
            $vod_area     = str_substr("制片国家/地区:</span> ","<br/>", $data); // 地区
            $vod_lang     = str_substr("语言:</span> ","<br/>", $data); // 语言
            
            $d_subname    = str_substr("又名:</span> ","<br/>", $data);
            $vod_sub      = str_replace("'", "’", $d_subname); // 别名
            
            $txt3         = str_substr("上映日期:</span> ","<br/>", $data);
            $vod_pubdate  = preg_replace("/<span[^>]*>(.*)<\/span>/isU", '${1}', $txt3); // 上映日期
            
            $vod_duration = str_substr('片长:</span> <span property="v:runtime" content="','">', $data); // 片长
            
            // 使用正则匹配剧情详情
            preg_match('/<span\s+property="v:summary"[^>]*>(.*?)<\/span>/is', $data, $summary_matches);
            $d_content = !empty($summary_matches[1]) ? $summary_matches[1] : '';
            
            // 如果未匹配到，尝试折叠状态的详情
            if (empty($d_content)) {
                $d_content = str_substr('<span class="all hidden">', '</span>', $data);
            }
            
            // 清理内容并处理空值
            $vod_content = cutstr_html($d_content);
            if (empty($vod_content)) {
                $vod_content = '内详';
            }
            
            
            $vod_total    = ''; // 集数
            
            // 根据地区设置备注
            if(strpos($vod_area, "中国") !== false){
                $vod_remarks = '高清国语';
            } elseif(strpos($vod_area, "台湾") !== false){
                $vod_remarks = '高清国语';
            } else {
                $vod_remarks = '高清中字';
            }
            
            if(empty($vod_sub)){
                $vod_sub = $d_name . $vod_year;
            }
            if(empty($vod_year)){
                $vod_year = '内详';
            }
            if(empty($vod_score)){
                $vod_score = rand(1,4).'.'.rand(0,9);
            }
            if(empty($vod_director)){
                $vod_director = '内详';
            }
            if(empty($vod_actor)){
                $vod_actor = '内详';
            }
            if(empty($vod_content)){
                $vod_content = '内详';
            }
            
            // 定义未设置的变量
            $vod_author = '';
            
            // 构造返回数据
            $info = array();
            $info['vod_name']         = $d_name;
            $info['vod_sub']          = $vod_sub . ',' . $d_name;
            $info['vod_year']         = $vod_year;
            $info['vod_lang']         = $vod_lang;
            $info['vod_area']         = $vod_area;
            $info['vod_remarks']      = $vod_remarks;
            $info['vod_total']        = $vod_total;
            $info['vod_serial']       = '';
            $info['vod_isend']        = 1;
            $info['vod_class']        = $vod_class;
            $info['vod_tag']          = '';
            $info['vod_actor']        = $vod_actor;
            $info['vod_director']     = $vod_director;
            $info['vod_pubdate']      = $vod_pubdate;
            $info['vod_writer']       = $vod_writer;
            $info['vod_score']        = $vod_score;
            $info['vod_score_num']    = rand(100,1000);
            $info['vod_score_all']    = rand(200,500);
            $info['vod_douban_score'] = $vod_score;
            $info['vod_duration']     = strip_tags($vod_duration);
            $info['vod_reurl']        = $vod_reurl;
            $info['vod_author']       = $vod_author;
            $info['vod_content']      = cutstr_html($vod_content);
            $info['vod_douban_id']    = $id;
            
            $vurl = '({"code":1,"auth":"冷曦博客免费转发分享！","msg":"博客www.lengxi.net","data":'.json_encode($info).'});';
        }
    }
    echo $callback . $vurl;
} else {
    echo $callback . '({"code":102,"auth":"冷曦博客免费转发分享！","msg":"博客www.lengxi.net"});';
}

//------------------自定义函数---------------------

function baohan($str, $needle){
    $tmparray = explode($needle, $str);
    return count($tmparray) > 1 ? '1' : '2';
}

function tugeturl($url){
    // 使用随机User-Agent模拟浏览器请求
    $userAgents = array(
       'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/98.0.4758.102 Safari/537.36',
       'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:91.0) Gecko/20100101 Firefox/91.0',
       'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/15.1 Safari/605.1.15',
       'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/98.0.4758.102 Safari/537.36'
    );
    $randomUserAgent = $userAgents[array_rand($userAgents)];
    if(function_exists('curl_init')){
        $ch = curl_init();
        $timeout = 30;
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, true);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_REFERER, "https://www.google.com");
        curl_setopt($ch, CURLOPT_USERAGENT, $randomUserAgent);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
        $handles = curl_exec($ch);
        curl_close($ch);
    } else {
        $handles = @file_get_contents($url);
    }
    return $handles;
}

function geturl($url){
    // 使用随机User-Agent模拟浏览器请求
    $userAgents = array(
       'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/98.0.4758.102 Safari/537.36',
       'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:91.0) Gecko/20100101 Firefox/91.0',
       'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/15.1 Safari/605.1.15',
       'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/98.0.4758.102 Safari/537.36'
    );
    $randomUserAgent = $userAgents[array_rand($userAgents)];
    if(function_exists('curl_init')){
        $ch = curl_init();
        $timeout = 30;
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_REFERER, "https://www.google.com");
        curl_setopt($ch, CURLOPT_USERAGENT, $randomUserAgent);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        $handles = curl_exec($ch);
        curl_close($ch);
    } else {
        $handles = @file_get_contents($url);
    }
    return $handles;
}

function getvrl($url){
    return str_replace(array('"',"'"), array("'", "‘"), $url);
}

function cutstr_html($string){
    $string = strip_tags($string);
    $string = trim($string);
    $search = array("\t", "\r\n", "\r", "\n", " ", "　");
    $string = str_replace($search, "", $string);
    return trim($string);
}

function str_substr($start, $end, $str){
    $temp = explode($start, $str, 2);
    if(count($temp) < 2) return '';
    $content = explode($end, $temp[1], 2);
    return $content[0];
}
?>
